<?php
/*******************************************************************
 *			
 * 			Fichier			:	functions.validate.php 
 * 			Cr le			:	10 janvier 2002 
 * 			Dernire modif	:	10 avril 2003 
 * 			Email			:	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


if( !defined('FUNCTIONS_VALIDATE_INC') )
{

define('FUNCTIONS_VALIDATE_INC', true); 

function check_email($email, $liste = 0, $action = '')
{
	global $db, $nl_config, $lang; 
	
	if( !ereg('^[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+'.
			  '@'.'[-!#$%&\'*+\\/0-9=?A-Z^_`a-z{|}~]+\.'.
			  '[-!#$%&\'*+\\./0-9=?A-Z^_`a-z{|}~]+$', $email) )
	{
		return array('error' => true, 'message' => $lang['Message']['Invalid_email']);
	}
	
	$row = ''; 
	if( $liste )
	{
		$sql = 'SELECT ban_email FROM ' . BANLIST_TABLE . ' 
			WHERE liste_id = ' . $liste; 
		if( $result = $db->query($sql) )
		{
			while( $row = $db->fetch_array($result) )
			{
				if( preg_match('/\b' . str_replace('*', '.*?', $row['ban_email']) . '\b/i', $email) )
				{
					return array('error' => true, 'message' => $lang['Message']['Email_banned']);
				}
			}
		}
		
		$sql = "SELECT a.*, COUNT(al.abo_id) AS is_registered 
				FROM " . ABONNES_TABLE . " AS a 
				LEFT JOIN " . ABO_LISTE_TABLE . " AS al ON a.abo_id = al.abo_id AND al.liste_id = $liste 
				WHERE LOWER(a.abo_email) = '" . strtolower($email) . "' 
				GROUP BY a.abo_id"; 
		if( !($result = $db->query($sql)) )
		{
			trigger_error('Impossible de tester les tables d\'inscriptions', ERROR); 
		}
		
		if( $row = $db->fetch_array($result) )
		{
			if( $row['is_registered'] )
			{
				if( $action == 'inscription' )
				{
					return array('error' => true, 'message' => $lang['Message']['Allready_reg']); 
				}
			}
			else
			{
				if( $action == 'desinscription' || $action == 'setformat' )
				{
					return array('error' => true, 'message' => $lang['Message']['Unknown_email']); 
				}
			}
			
			if( $action == 'confirmation' && $row['abo_status'] == ABO_ACTIF )
			{
				return array('error' => true, 'message' => $lang['Message']['Allready_confirm']); 
			}
		}
		else if( $action != 'inscription' )
		{
			return array('error' => true, 'message' => $lang['Message']['Unknown_email']); 
		}
	}
		
	return array('error' => false, 'abo_data' => $row); 
}

}
?>